module.exports = function(client, views){

    var JOB_TYPE     = "JobRegistry";
    var JOB_TYPE_RESOURCE = ['resources', JOB_TYPE].join('/');
    var prompt   = require('prompt');
    var utils    = require('./jobUtils');

    //function toEntity(err, response, body){
    //    if(err || response.statusCode !== 200){
    //        var reason = err ? (err.code || err) : response.statusCode
    //        console.log('error %s: unable to find the %s %s', reason, JOB_TYPE)
    //    } else {
    //        if(body.length > 0){
    //            //name exists
    //        } else {
    //            client.post(resource, jobType, function(err, response, body){
    //                //print out the name of the job
    //            })
    //        }
    //    }
    //}

    function register(options){

        prompt.message = JOB_TYPE;
        prompt.delimiter = ":".green;

        var schema = {
            properties: {
                name: {
                    description: 'Enter the node package that contains the job'.green,
                    pattern: /^[a-zA-Z\s\-]+$/,
                    message: 'Module must be only letters, spaces, or dashes and represent a valid NPM packge',
                    required: true
                },
                publisher: {
                    description: 'who is publishing the job'.green,
                    message: 'Publisher of the job',
                    required: true
                },
                description: {
                    type   : 'string',
                    default: '',
                    message: 'Quick description of what the job is for'
                }
            }
        };

        prompt.start();

        prompt.get(schema, function (err, representation) {
            console.log('Creating new job with name %s', representation.name);
            client.post(JOB_TYPE_RESOURCE, representation, views.full);
        });

    }

    function list(){
        client.get(JOB_TYPE_RESOURCE, views.entity);
    }

    //This is a more critical
    function unregister(id, options){
        var resource = utils.createResource(JOB_TYPE, id, options);
        console.log('deleting %s', resource);
        client.delete(utils.createResource(JOB_TYPE, id, options), views.status);
    }

    return {
        register  : register,       //done
        list      : list,           //done
        unregister: unregister      //done
    }

}
