var util = require('util');

function resourceById(resource, id){
    return ['resources', resource, id].join('/');
}

function resourceByName(resource, name){
    return ['resources', resource].join('/') + '?where={"name":"' + name + '"}'
}

function resourceByParameter(resource, name, value){
    var scope = util.format('?where={"%s":"%s"}', name, value);
    return ['resources', resource].join('/') + scope;
}

var assertIdentifier = exports.assertIdentifier = function assertIdentifier(id, options) {
    if (!(id || options.name || options.number)) {
        console.log('invalid parameters - expecting an id,  --name or --number');
        process.exit(1);
    }
};

exports.createResource = function createResource(resource, id, options){
    assertIdentifier(id, options);

    var fragment;

    if(options.number){
        console.log('trying number');
        fragment = resourceByParameter(resource, 'store_number', options.number)
    } else if (options.name){
        fragment = resourceByName(resource, options.name)
    } else {
        fragment = resourceById(resource, id);
    }

    return fragment;
};
